package com.live.mylivewallpaper.paging;


import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.paging.PagingSource;
import androidx.paging.PagingState;

import com.live.mylivewallpaper.data.LikeData;
import com.live.mylivewallpaper.help.Common;
import com.live.mylivewallpaper.help.Db;

import java.util.List;

import kotlin.coroutines.Continuation;

public class MyLikeSource extends PagingSource<Integer, LikeData> {
     public static int pageSize = 10;


    public MyLikeSource() {

    }

    @Nullable
    @Override
    public Integer getRefreshKey(@NonNull PagingState<Integer, LikeData> pagingState) {
        return null;
    }

    @Nullable
    @Override
    public Object load(@NonNull LoadParams<Integer> loadParams, @NonNull Continuation<? super LoadResult<Integer, LikeData>> continuation) {

        try {
            int page = loadParams.getKey() != null ? loadParams.getKey() : 1;

            List<LikeData> data = Db.queryLike(page);
            Common.logMsg("-----loadLIke---------page="+page+"--data="+data.size());
            return new LoadResult.Page<>(
                    data,
                    page > 1 ? page - 1 : null,
                    data.isEmpty() ? null : page + 1
            );
        } catch (Exception e) {
            return new LoadResult.Error<>(e);
        }
    }
}

